/*
 * File.h
 *
 *  Created on: Jan 31, 2017
 *      Author: vagner
 */

#pragma once

#include <fstream>
#include <string>

namespace vCommon
{
	/*
	 *	Утилиты работы с файлами
	 */
	class File
	{
	public:
		//
		//	дописать в конец файла
		//
		static long Append ( const std::string& FileName, const void* Content, int ContentSize );
		//
		//	скопировать файл
		//
		static bool Copy ( const std::string& srcFileName, const std::string& dstFileName );
        //
        //  Delete
        //
        static bool Delete ( const std::string& FileName );
		//
		//	получить MD5 файла
		//
		static std::string getFileMD5 ( const std::string& FileName );
        //
        //  существует ли файл?
        //
        static bool IsExists ( const std::string& FileName );
        //
        //  Move
        //
        static bool Move ( const std::string& src, const std::string& dst );
		//
		//	прочитать содержимое файла в виде текста
		//
		static std::string ReadAllText ( const std::string& FileName );
		//
		//	прочитать из файла указанное количество байт (буфер заказчика)
		//
		static void* ReadBytes ( const std::string& FileName, void* buf, int size, int* read_size = nullptr );
		//
		//	прочитать из файла указанное количество байт (буфер наш)
		//
		static void* ReadBytes ( const std::string& FileName, int size, int* read_size = nullptr );
		//
		//	записать в файл
		//
		static long Write ( const std::string& FileName, const void* Content, int ContentSize );
		//
		//	записать в файл
		//
		static long exWrite ( const std::string& FileName, const void* Content, int ContentSize
			, std::ofstream::openmode OpenMode );
	};

} /* namespace vCommon */
